#!/usr/bin/env perl
use 5.016;
use ZMQ::LibZMQ3;
use ZMQ::Constants qw(ZMQ_REP ZMQ_FD);
use AnyEvent;

my $context = zmq_init();
my $server = zmq_socket($context, ZMQ_REP);
zmq_bind($server, 'tcp://*:10001');
my $fd = zmq_getsockopt( $server, ZMQ_FD );

my $w = AnyEvent->io(
    fh   => $fd,
    poll => "r",
    cb   => sub {
        my $msg = zmq_msg_data(zmq_recvmsg($server));
        say "server got >$msg<";
        zmq_send( $server, "Hello $msg!" );
        say "replied with >Hello $msg!<";
    },
);
AnyEvent->condvar->recv;
