#!/usr/bin/env perl
use 5.016;
use ZMQ::LibZMQ3;
use ZMQ::Constants qw(ZMQ_SUB ZMQ_FD ZMQ_SUBSCRIBE ZMQ_RCVMORE);
use AnyEvent;

my $context = zmq_init();
my $subscriber = zmq_socket($context, ZMQ_SUB);
zmq_connect($subscriber, 'tcp://localhost:10001');
zmq_setsockopt( $subscriber, ZMQ_SUBSCRIBE, $ARGV[0] || '' );
my $fd = zmq_getsockopt( $subscriber, ZMQ_FD );

my $w = AnyEvent->io(
    fh   => $fd,
    poll => "r",
    cb   => sub {
        my @parts;
        while ( my $rmsg = zmq_recvmsg( $subscriber)) {
            push (@parts,zmq_msg_data( $rmsg ));
            if (!zmq_getsockopt($subscriber, ZMQ_RCVMORE)) {
                say "artist $parts[1] released song $parts[3] on $parts[2]";
                @parts=();
            }
        }
    },
);
AnyEvent->condvar->recv;
