#!/usr/bin/env perl
use 5.016;
use ZMQx::Class;
use ZMQx::Class::AnyEvent;

my $in  = ZMQx::Class->socket('PULL', connect=>'tcp://localhost:10002', {
    rcvhwm=>1,
});
my $out = ZMQx::Class->socket('PUB',  connect=>'tcp://localhost:10003');

say "Worker $$ up & running";

my $w = ZMQx::Class::AnyEvent->watcher( $in, sub {
    while (my $message = $in->receive) {
        my ($task_id, $index, $word) = @$message;

        my $cost = length( $word );
        sleep( $cost );

        say "$task_id: handled by worker $$: $index:$word:$cost";
        $out->send([$task_id, $index, $word, $cost, $$]);
    }
});
AnyEvent->condvar->recv;
